from subprocess import call
import argparse

arg_object = argparse.ArgumentParser()
arg_object.add_argument('tf1', help='Contiguous k-mer file for TF 1',
                        metavar = 'tf1_8mer_file.txt')
arg_object.add_argument('tf2', help='k-mer file for TF 2',
                        metavar = 'tf2_8mer_file.txt')
arg_object.add_argument('output_file', help='Output png file',
                        metavar = 'output_file.png')
arg_object.add_argument('-N', help='Number of significant k-mers to plot',
                        default = 3, type = int)
arg_object.add_argument('name1', help='Name of first TF given (for plotting)',
                         type = str)
arg_object.add_argument('name2', help='Name of second TF given (for plotting)',
                         type = str)
arg_object.add_argument('rpath', help='Absolute path of R scripts',
                        metavar = 'R_script_path')


args = arg_object.parse_args()

R_script_path = '/Users/boj/Documents/PBM/Bayesian_PBM_Analysis/'

R_call = " R CMD BATCH '--args %s %s %s %s %s %s %s' %s/preferred.cmd.r" \
         %(args.tf1, args.tf2, args.N, args.output_file, args.name1, args.name2, args.rpath, args.rpath)

call(R_call, shell = True)