##############################################
##Specification of dir, input and output dir##
##############################################
##Set working directory, which contains the directory "Bayesian_PBM_Analysis"
dir <- "/Users/boj/Documents/PBM/"
dir <- paste(dir,"Bayesian_PBM_Analysis/",sep="")

#Set directory that contains input files (kmer file, observed E-score file and names of TFs) and output direcotry
dir <- paste(dir,"partition_example/",sep="")

#Set input files
kmer.file <- "kmers.txt"
score.file <- "score_homeo.txt"
name.file <- "names_homeo.txt"

#Set output directory, which contains the output results from running "pbm.partition"
output.dir <- paste(dir,"output_homeo/",sep="")

##########################################
##Analysis of results from pbm.partition##
##########################################
partition.result <- function(dir, score.file, name.file, kmer.file, output.dir, group=NULL)
{
    setwd(dir)
    library(gplots)
    
    #Read observed E-score file
    x<- read.table(score.file,header=F)
    x <- as.matrix(x)
    #Read TF name file
    name <- read.table(name.file,header=F)
    names <- name$V1
    domain <- name$V2
    
    setwd(output.dir)
    #Read results from output directory
    #trace<- read.table("trace.txt",header=F)
    #trace <- trace$V1
    #plot(trace,type="l",main="Trace Plot",ylab="Log-Likelihood")
    gy <- read.table("resultgy.txt",header=F)
    cy <- read.table("resultcy.txt",header=F)
    yr <- read.table("resulty.txt",header=F)
    yr <- as.matrix(yr)
    yg <- read.table("resultyg.txt",header=F)
    yg <- as.matrix(yg)
    c <- read.table("resultc.txt",header=F)
    c <- as.matrix(c)
    yid <- seq(1:dim(yr)[1])
    id2 <- yid[yr[,2]>0.8]
    length(id2)
    x <- t(x)
    ny <- dim(gy)[1]
    ng <- dim(gy)[2]
    ni <- dim(cy)[2]
    gid <- seq(1:ny)
    id1 <- gid[apply(yg,1,which.max)==1]
    id3 <- NULL
    xx <- NULL
    yy <- NULL
    for(i in 1:length(id2))
    {
        id1 <- gid[apply(yg,1,which.max)==id2[i]+1]
        xx <- cbind(xx,x[,id1])
        yy <- c(yy,rep(i,length(id1)))
        id3 <- c(id3,id1)
        #print(length(id1))
    }
    x <- t(x)
    #Number and size of subclasses
    cc <- apply(c[501:1000,],2,max)
    #print(table(cc))
    
    setwd(dir)
    #Heatmap of subclass-preferred k-mer groups
    pdf(file=paste(dir,"subclass_heatmap.pdf",sep=""))
    heatmap.2(xx, col=topo.colors(75), scale="none", distfun=dist, dendrogram="row", Rowv=T, Colv=F,
    key=TRUE, symkey=FALSE, density.info="none",trace="none",
    labCol="", labRow=names, cexRow=0.25, margins = c(1, 8))	
    dev.off()
    
    if(length(group)!=0)
    {
        kmers <- read.table(kmer.file,header=F)
        #8-mer sequences of k-mer group
        id <- id3[yy==group]
        seq <- as.matrix(kmers[id,1])
        write(seq,file=sprintf("kmers.group%d.seq",group))
    } else {
        kmers <- read.table(kmer.file,header=F)
        for(group in 1:max(yy))
        {
            #8-mer sequences of k-mer group
            id <- id3[yy==group]
            seq <- as.matrix(kmers[id,1])
            write(seq,file=sprintf("kmers.group%d.seq",group))
        }
    }
}

partition.result(dir, score.file, name.file, kmer.file, output.dir)
