#########################################
##Specification of dir, file1 and file2##
#########################################
##Set working directory, which contains the directory "Bayesian_PBM_Analysis"
dir <- "/Users/boj/Documents/PBM/"
dir <- paste(dir,"Bayesian_PBM_Analysis/",sep="")
setwd(dir)
source("preferred.analysis.r")
load("kmer.6.RData")

#Set input and output directory
dir <- paste(dir,"preferred_example/",sep="")

##Files have the first three columns as: "8-mer, 8-mer(reverse complementary), and observed E-score" and separated by tab
#1st PBM observed E-score file
file1 <- "Lhx2_0953.2_contig8mers.txt"

#2nd PBM observed E-score file
file2 <- "Lhx4_1719.2_contig8mers.txt"

##specify the set of 6-mers to be plotted, if NULL top k singificant 6-mers will be plotted
kmers.6 <- NULL
k <- 3

#########################
##Find Preferred 6-mers##
#########################
#caculat p-values and output significant 6-mers: preferred.pvalue(dir, file1, file2, mu1=2.0, mu2=0.0, level=0.05, p.adjust.method="fdr")
##mu1 and mu2 controls the practical significant level, mu2 may need to be adjusted to 0.5 if practical significance is too small
result <- preferred.pvalue(dir, mu2=0.0, file1, file2)
#6-mers preferred by the 1st pbm experiment
result$preferred.1
#6-mers preferred by the 2nd pbm experiment
result$preferred.2

#########################
##Plot Preferred 6-mers##
#########################
if(length(kmers.6)==0)
{
    #plot top k 6-mers if kmers.6 is not specified
    kmers.6.1 <- as.character(result$preferred.1$six.mer)
    kmers.6.2 <- as.character(result$preferred.2$six.mer)
    kmers.6 <- c(kmers.6.1[1:min(length(kmers.6.1),k)],kmers.6.2[1:min(length(kmers.6.2),k)])
}
#scatter plot: preferred.plot(dir, file1, file2, kmers.6, xlab="Replicate 1",ylab = "Replicate 2",xlim=c(-0.5,0.5),ylim=c(-0.5,0.5),main="Scatter Plot of 8-mer E-scores")
setwd(dir)
pdf(file=paste(dir,"preferred_analysis_plot.pdf",sep=""))
preferred.plot(dir, file1, file2, kmers.6,xlab="Lhx2",ylab="Lhx4")
dev.off()


###########################
##Output Preferred 6-mers##
###########################
setwd(dir)
write.table(result$preferred.1, sep="\t", file="preferred.tf1.txt",row.names=F,quote=F)
write.table(result$preferred.2, sep="\t", file="preferred.tf2.txt",row.names=F,quote=F)


